import { DatePickerProps } from 'antd/es/date-picker/interface';
import { TextAreaProps } from 'antd/es/input';

export interface CommonProps {
    onEmitChange?: Function;
    emitTrigger?: string;
}
export interface InputProps extends CommonProps {
    maxLength: number;
}
export interface LinkProps extends CommonProps {
    value: any[];
    maxLength: number;
}
export interface LinkState {
    prevProps: LinkProps;
    value: any[];
}
export interface ApolloTextAreaProps extends TextAreaProps, CommonProps {
    value: string | undefined;
}
export interface SearchProps extends CommonProps {
    type: string;
    isMultiple?: boolean;
    maxCount?: number;
    tableId?: number;
    paramsJson?: any;
}
export interface SelectProps extends CommonProps {
    isMultiple?: boolean;
    maxCount?: number;
    tableId?: number;
    options?: any[];
    allowClear?: boolean;
}
export interface RateProps {
    value: number;
    allowClear?: boolean;
    allowHalf?: boolean;
    count?: number;
    onChange: any;
    disabled?: boolean;
}
export interface NumberProps {
    value: number | undefined;
    onChange: Function;
    cellData?: any[];
    floatRange?: number;
    rowId?: number;
    columnConfig?: any;
    precision: number;
    min: number;
    max: number;
    step?: number | string;
}
export interface NumberState {
    prevProps: NumberProps;
    value: number | undefined;
    cellData?: any[];
}
export interface DateProps extends DatePickerProps {}
